package com.huimv.farm.damsubsidy.controller;


import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillLandingInspection;
import com.huimv.farm.damsubsidy.service.IBillLandingInspectionService;
import com.huimv.farm.damsubsidy.service.impl.BillLandingInspectionServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.sql.Date;
import java.time.LocalDateTime;
import java.util.Map;

/**
 * <p>
 * 落地检 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-landing-inspection")
@CrossOrigin
public class BillLandingInspectionController {
    @Autowired
    private IBillLandingInspectionService iBillLandingInspectionService;

    @PostMapping("/addApplication")
    public Result addApplication(HttpServletRequest httpServletRequest, @RequestBody BillLandingInspection billLandingInspection){
        return iBillLandingInspectionService.addApplication(httpServletRequest,billLandingInspection);
    }

    @PostMapping("/cancelApplication")
    public Result cancelApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillLandingInspectionService.cancelApplication(httpServletRequest,paramsMap);
    }

    @PostMapping("agreeApplication")
    public Result agreeApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillLandingInspectionService.agreeApplication(httpServletRequest,paramsMap);
    }

    @PostMapping("/listApplication")
    public Result listApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillLandingInspectionService.listApplication(httpServletRequest,paramsMap);
    }

    @PostMapping("/listDetail")
    public Result listDetail(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return new Result(ResultCode.SUCCESS,iBillLandingInspectionService.getById(id));
    }

    @PostMapping("/rejectApplication")
    public Result rejectApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillLandingInspectionService.rejectApplication(httpServletRequest,paramsMap);
    }

    @PostMapping("listReadyApplication")
    public Result listReadyApplication(){
        return new Result(ResultCode.SUCCESS,iBillLandingInspectionService.list(new QueryWrapper<BillLandingInspection>()
                .eq("inspection_sch",4)
                .eq("is_delete",0)));
    }


    @Autowired
    private IBillLandingInspectionService billLandingInspectionService;

    @RequestMapping("/list")
    public Result list(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
       return billLandingInspectionService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return billLandingInspectionService.listById(httpServletRequest, paramsMap);
    }
}
