package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.common.utils.UploadImage;
import com.huimv.farm.damsubsidy.entity.BaseAnimal;
import com.huimv.farm.damsubsidy.entity.BillBuyInfo;
import com.huimv.farm.damsubsidy.mapper.BaseAnimalMapper;
import com.huimv.farm.damsubsidy.mapper.BillBuyInfoMapper;
import com.huimv.farm.damsubsidy.service.IBillBuyInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 交易信息 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BillBuyInfoServiceImpl extends ServiceImpl<BillBuyInfoMapper, BillBuyInfo> implements IBillBuyInfoService {
    @Resource
    private BaseAnimalMapper baseAnimalMapper;
    @Resource
    private BillBuyInfoMapper billBuyInfoMapper;

    @Override
    @Transactional
    public Result addTransaction(HttpServletRequest httpServletRequest, MultipartFile image1, MultipartFile image2, MultipartFile image3, String inspectionNum, String seller, String buyer, String num, String eartags) {
        String imgname = "成功";
        String originalFilename = image1.getOriginalFilename();
        String filenameExtension = StringUtils.getFilenameExtension(originalFilename);
        String path = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image1.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content = out.toByteArray();
            imgname = UUID.randomUUID()+"."+filenameExtension;
            UploadImage.sshSftp(content,path, imgname);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content = "http://139.9.167.178/images/"+path +"/"+imgname;

        String imgname2 = "成功";
        String originalFilename2 = image2.getOriginalFilename();
        String filenameExtension2 = StringUtils.getFilenameExtension(originalFilename2);
        String path2 = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image2.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content2 = out.toByteArray();
            imgname2 = UUID.randomUUID()+"."+filenameExtension2;
            UploadImage.sshSftp(content2,path2, imgname2);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content2 = "http://139.9.167.178/images/"+path2 +"/"+imgname2;

        String imgname3 = "成功";
        String originalFilename3 = image3.getOriginalFilename();
        String filenameExtension3 = StringUtils.getFilenameExtension(originalFilename3);
        String path3 = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image3.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content3 = out.toByteArray();
            imgname3 = UUID.randomUUID()+"."+filenameExtension3;
            UploadImage.sshSftp(content3,path3, imgname3);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content3 = "http://139.9.167.178/images/"+path3 +"/"+imgname3;

        BillBuyInfo billBuyInfo = new BillBuyInfo();
        billBuyInfo.setInspectionNum(inspectionNum);
        billBuyInfo.setBuyerName(buyer);
        billBuyInfo.setSellerName(seller);
        billBuyInfo.setCreateUser(TokenSign.getUserName(httpServletRequest));
        billBuyInfo.setCreateTime(DateTime.now());
        billBuyInfo.setRealNumUp(num);
        billBuyInfo.setBuyPicUrl(content);
        billBuyInfo.setPayPicUrl(content2);
        billBuyInfo.setBuyPayGoodsPicUrl(content3);
        billBuyInfo.setRealEartag(eartags);
        billBuyInfo.setBillBuyStatus(2);
        this.save(billBuyInfo);

        if (eartags.contains(";")){
            String[] eartag = eartags.split(";");
            for (String input : eartag) {
                if (input.contains("-")){
                    String start = input.substring(0, input.indexOf("-"));
                    String end = input.substring(input.indexOf("-") + 1);
                    String substring = start.substring(0, start.length() - end.length());
                    String finish = substring+end;
                    List<Integer> numbers = new ArrayList<>();
                    for (int i = Integer.parseInt(start); i <= Integer.parseInt(finish); i++) {
                        numbers.add(i);
                    }
                    for (Integer number : numbers) {
                        String earatgNo = number.toString();
                        BaseAnimal baseAnimal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", earatgNo));
                        if (ObjectUtil.isEmpty(baseAnimal)){
                            return new Result(10001,"耳标号不存在",false);
                        }
                        baseAnimal.setBelongToUser(buyer);
                        baseAnimal.setBuyerName(buyer);
                        baseAnimal.setSellerName(seller);
                        baseAnimal.setAnimalStatus(2);
                        baseAnimal.setBuyTime(DateTime.now());
                        baseAnimalMapper.updateById(baseAnimal);
                    }
                }else {
                    BaseAnimal baseAnimal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", input));
                    if (ObjectUtil.isEmpty(baseAnimal)){
                        return new Result(10001,"耳标号不存在",false);
                    }
                    baseAnimal.setBelongToUser(buyer);
                    baseAnimal.setBuyerName(buyer);
                    baseAnimal.setSellerName(seller);
                    baseAnimal.setAnimalStatus(2);
                    baseAnimal.setBuyTime(DateTime.now());
                    baseAnimalMapper.updateById(baseAnimal);
                }
            }
        }else {
            if (eartags.contains("-")){
                String start = eartags.substring(0, eartags.indexOf("-"));
                String end = eartags.substring(eartags.indexOf("-") + 1);
                String substring = start.substring(0, start.length() - end.length());
                String finish = substring+end;
                List<Integer> numbers = new ArrayList<>();
                for (int i = Integer.parseInt(start); i <= Integer.parseInt(finish); i++) {
                    numbers.add(i);
                }
                for (Integer number : numbers) {
                    String earatgNo = number.toString();
                    BaseAnimal baseAnimal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", earatgNo));
                    if (ObjectUtil.isEmpty(baseAnimal)){
                        return new Result(10001,"耳标号不存在",false);
                    }
                    baseAnimal.setBelongToUser(buyer);
                    baseAnimal.setBuyerName(buyer);
                    baseAnimal.setSellerName(seller);
                    baseAnimal.setAnimalStatus(2);
                    baseAnimal.setBuyTime(DateTime.now());
                    baseAnimalMapper.updateById(baseAnimal);
                }
            }else {
                BaseAnimal baseAnimal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", eartags));
                if (ObjectUtil.isEmpty(baseAnimal)){
                    return new Result(10001,"耳标号不存在",false);
                }
                baseAnimal.setBelongToUser(buyer);
                baseAnimal.setBuyerName(buyer);
                baseAnimal.setSellerName(seller);
                baseAnimal.setAnimalStatus(2);
                baseAnimal.setBuyTime(DateTime.now());
                baseAnimalMapper.updateById(baseAnimal);
            }
        }
        return Result.SUCCESS();
    }

    @Override
    public Result saveTransaction(HttpServletRequest httpServletRequest, MultipartFile image1, MultipartFile image2, MultipartFile image3, String inspectionNum, String seller, String buyer, String num, String eartags) {
        String imgname = "成功";
        String originalFilename = image1.getOriginalFilename();
        String filenameExtension = StringUtils.getFilenameExtension(originalFilename);
        String path = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image1.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content = out.toByteArray();
            imgname = UUID.randomUUID()+"."+filenameExtension;
            UploadImage.sshSftp(content,path, imgname);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content = "http://139.9.167.178/images/"+path +"/"+imgname;

        String imgname2 = "成功";
        String originalFilename2 = image2.getOriginalFilename();
        String filenameExtension2 = StringUtils.getFilenameExtension(originalFilename2);
        String path2 = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image2.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content2 = out.toByteArray();
            imgname2 = UUID.randomUUID()+"."+filenameExtension2;
            UploadImage.sshSftp(content2,path2, imgname2);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content2 = "http://139.9.167.178/images/"+path2 +"/"+imgname2;

        String imgname3 = "成功";
        String originalFilename3 = image3.getOriginalFilename();
        String filenameExtension3 = StringUtils.getFilenameExtension(originalFilename3);
        String path3 = DateUtil.format(new Date(),"yyyy-MM");
        try {
            InputStream inputStream = image3.getInputStream();
            BufferedInputStream in = new BufferedInputStream(inputStream);
            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

            byte[] temp = new byte[1024];
            int size = 0;
            while ((size = in.read(temp)) != -1) {
                out.write(temp, 0, size);
            }
            in.close();
            byte[] content3 = out.toByteArray();
            imgname3 = UUID.randomUUID()+"."+filenameExtension3;
            UploadImage.sshSftp(content3,path3, imgname3);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String content3 = "http://139.9.167.178/images/"+path3 +"/"+imgname3;

        BillBuyInfo billBuyInfo = new BillBuyInfo();
        billBuyInfo.setInspectionNum(inspectionNum);
        billBuyInfo.setBuyerName(buyer);
        billBuyInfo.setSellerName(seller);
        billBuyInfo.setCreateUser(TokenSign.getUserName(httpServletRequest));
        billBuyInfo.setCreateTime(DateTime.now());
        billBuyInfo.setRealNumUp(num);
        billBuyInfo.setBuyPicUrl(content);
        billBuyInfo.setPayPicUrl(content2);
        billBuyInfo.setBuyPayGoodsPicUrl(content3);
        billBuyInfo.setRealEartag(eartags);
        billBuyInfo.setBillBuyStatus(1);
        this.save(billBuyInfo);
        return Result.SUCCESS();
    }

    @Override
    public Result getLast(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        return new Result(ResultCode.SUCCESS, billBuyInfoMapper.selectList(new QueryWrapper<BillBuyInfo>()
                .eq("bill_buy_status",1)
                .eq("create_user",TokenSign.getUserName(httpServletRequest))
                .orderByDesc("create_time")
                .last("limit 1")));
    }
}
